From e5b657fe11523c9b24a6f6098dbdb1bdba58003e Mon Sep 17 00:00:00 2001
From: "Gao,Yan" <ygao@suse.com>
Date: Fri, 1 Mar 2019 17:32:50 +0100
Subject: [PATCH 3/3] Test: scheduler: cl#5301 - respect order constraints when
 relevant resources are being probed (new test)

---
 pengine/regression.sh                     |   1 +
 pengine/test10/order-first-probes.dot     |  28 ++++++
 pengine/test10/order-first-probes.exp     | 144 ++++++++++++++++++++++++++++++
 pengine/test10/order-first-probes.scores  |  12 +++
 pengine/test10/order-first-probes.summary |  35 ++++++++
 pengine/test10/order-first-probes.xml     |  96 ++++++++++++++++++++
 6 files changed, 316 insertions(+)
 create mode 100644 pengine/test10/order-first-probes.dot
 create mode 100644 pengine/test10/order-first-probes.exp
 create mode 100644 pengine/test10/order-first-probes.scores
 create mode 100644 pengine/test10/order-first-probes.summary
 create mode 100644 pengine/test10/order-first-probes.xml

Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/regression.sh
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/regression.sh
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/regression.sh
@@ -568,6 +568,7 @@ do_test honor_stonith_rsc_order2 "cl#505
 do_test honor_stonith_rsc_order3 "cl#5056- Honor order constraint, stonith clones with nested pure stonith group."
 do_test honor_stonith_rsc_order4 "cl#5056- Honor order constraint, between two native stonith rscs."
 do_test probe-timeout "cl#5099 - Default probe timeout"
+do_test order-first-probes "cl#5301 - respect order constraints when relevant resources are being probed"
 
 do_test concurrent-fencing "Allow performing fencing operations in parallel"
 
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.dot
===================================================================
--- /dev/null
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.dot
@@ -0,0 +1,31 @@
+digraph "g" {
+"all_stopped" [ style=bold color="green" fontcolor="orange"]
+"grpDummy_running_0" [ style=bold color="green" fontcolor="orange"]
+"grpDummy_start_0" -> "grpDummy_running_0" [ style = bold]
+"grpDummy_start_0" -> "prmDummy1_start_0 rh72-02" [ style = bold]
+"grpDummy_start_0" -> "prmDummy2_start_0 rh72-02" [ style = bold]
+"grpDummy_start_0" [ style=bold color="green" fontcolor="orange"]
+"grpDummy_stop_0" -> "grpDummy_stopped_0" [ style = bold]
+"grpDummy_stop_0" -> "prmDummy1_stop_0 rh72-01" [ style = bold]
+"grpDummy_stop_0" [ style=bold color="green" fontcolor="orange"]
+"grpDummy_stopped_0" -> "grpDummy_start_0" [ style = bold]
+"grpDummy_stopped_0" [ style=bold color="green" fontcolor="orange"]
+"prmDummy1_monitor_10000 rh72-02" [ style=bold color="green" fontcolor="black"]
+"prmDummy1_start_0 rh72-02" -> "grpDummy_running_0" [ style = bold]
+"prmDummy1_start_0 rh72-02" -> "prmDummy1_monitor_10000 rh72-02" [ style = bold]
+"prmDummy1_start_0 rh72-02" -> "prmDummy2_start_0 rh72-02" [ style = bold]
+"prmDummy1_start_0 rh72-02" [ style=bold color="green" fontcolor="black"]
+"prmDummy1_stop_0 rh72-01" -> "all_stopped" [ style = bold]
+"prmDummy1_stop_0 rh72-01" -> "grpDummy_stopped_0" [ style = bold]
+"prmDummy1_stop_0 rh72-01" -> "prmDummy1_start_0 rh72-02" [ style = bold]
+"prmDummy1_stop_0 rh72-01" [ style=bold color="green" fontcolor="black"]
+"prmDummy2_monitor_0 rh72-01" -> "all_stopped" [ style = bold]
+"prmDummy2_monitor_0 rh72-01" -> "grpDummy_stopped_0" [ style = bold]
+"prmDummy2_monitor_0 rh72-01" -> "prmDummy1_stop_0 rh72-01" [ style = bold]
+"prmDummy2_monitor_0 rh72-01" -> "prmDummy2_start_0 rh72-02" [ style = bold]
+"prmDummy2_monitor_0 rh72-01" [ style=bold color="green" fontcolor="black"]
+"prmDummy2_monitor_10000 rh72-02" [ style=bold color="green" fontcolor="black"]
+"prmDummy2_start_0 rh72-02" -> "grpDummy_running_0" [ style = bold]
+"prmDummy2_start_0 rh72-02" -> "prmDummy2_monitor_10000 rh72-02" [ style = bold]
+"prmDummy2_start_0 rh72-02" [ style=bold color="green" fontcolor="black"]
+}
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.exp
===================================================================
--- /dev/null
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.exp
@@ -0,0 +1,159 @@
+<transition_graph cluster-delay="60s" stonith-timeout="60s" failed-stop-offset="INFINITY" failed-start-offset="INFINITY"  transition_id="0">
+  <synapse id="0">
+    <action_set>
+      <pseudo_event id="12" operation="stopped" operation_key="grpDummy_stopped_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="prmDummy2_monitor_0" on_node="rh72-01" on_node_uuid="3232238257"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="stop" operation_key="prmDummy1_stop_0" on_node="rh72-01" on_node_uuid="3232238257"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="11" operation="stop" operation_key="grpDummy_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="1">
+    <action_set>
+      <pseudo_event id="11" operation="stop" operation_key="grpDummy_stop_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="2">
+    <action_set>
+      <pseudo_event id="10" operation="running" operation_key="grpDummy_running_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="5" operation="start" operation_key="prmDummy1_start_0" on_node="rh72-02" on_node_uuid="3232238258"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="7" operation="start" operation_key="prmDummy2_start_0" on_node="rh72-02" on_node_uuid="3232238258"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="9" operation="start" operation_key="grpDummy_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="3">
+    <action_set>
+      <pseudo_event id="9" operation="start" operation_key="grpDummy_start_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="12" operation="stopped" operation_key="grpDummy_stopped_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="4">
+    <action_set>
+      <rsc_op id="6" operation="monitor" operation_key="prmDummy1_monitor_10000" on_node="rh72-02" on_node_uuid="3232238258">
+        <primitive id="prmDummy1" class="ocf" provider="pacemaker" type="Dummy1"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="rh72-02" CRM_meta_on_node_uuid="3232238258" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="5" operation="start" operation_key="prmDummy1_start_0" on_node="rh72-02" on_node_uuid="3232238258"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="5">
+    <action_set>
+      <rsc_op id="5" operation="start" operation_key="prmDummy1_start_0" on_node="rh72-02" on_node_uuid="3232238258">
+        <primitive id="prmDummy1" class="ocf" provider="pacemaker" type="Dummy1"/>
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="rh72-02" CRM_meta_on_node_uuid="3232238258" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="4" operation="stop" operation_key="prmDummy1_stop_0" on_node="rh72-01" on_node_uuid="3232238257"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="9" operation="start" operation_key="grpDummy_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="6">
+    <action_set>
+      <rsc_op id="4" operation="stop" operation_key="prmDummy1_stop_0" on_node="rh72-01" on_node_uuid="3232238257">
+        <primitive id="prmDummy1" class="ocf" provider="pacemaker" type="Dummy1"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_on_node="rh72-01" CRM_meta_on_node_uuid="3232238257" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="prmDummy2_monitor_0" on_node="rh72-01" on_node_uuid="3232238257"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="11" operation="stop" operation_key="grpDummy_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="7">
+    <action_set>
+      <rsc_op id="8" operation="monitor" operation_key="prmDummy2_monitor_10000" on_node="rh72-02" on_node_uuid="3232238258">
+        <primitive id="prmDummy2" class="ocf" provider="pacemaker" type="Dummy2"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="rh72-02" CRM_meta_on_node_uuid="3232238258" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="7" operation="start" operation_key="prmDummy2_start_0" on_node="rh72-02" on_node_uuid="3232238258"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="8">
+    <action_set>
+      <rsc_op id="7" operation="start" operation_key="prmDummy2_start_0" on_node="rh72-02" on_node_uuid="3232238258">
+        <primitive id="prmDummy2" class="ocf" provider="pacemaker" type="Dummy2"/>
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="rh72-02" CRM_meta_on_node_uuid="3232238258" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="prmDummy2_monitor_0" on_node="rh72-01" on_node_uuid="3232238257"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="start" operation_key="prmDummy1_start_0" on_node="rh72-02" on_node_uuid="3232238258"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="9" operation="start" operation_key="grpDummy_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="9">
+    <action_set>
+      <rsc_op id="3" operation="monitor" operation_key="prmDummy2_monitor_0" on_node="rh72-01" on_node_uuid="3232238257">
+        <primitive id="prmDummy2" class="ocf" provider="pacemaker" type="Dummy2"/>
+        <attributes CRM_meta_on_node="rh72-01" CRM_meta_on_node_uuid="3232238257" CRM_meta_op_target_rc="7" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="10">
+    <action_set>
+      <pseudo_event id="2" operation="all_stopped" operation_key="all_stopped">
+        <attributes />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="prmDummy2_monitor_0" on_node="rh72-01" on_node_uuid="3232238257"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="stop" operation_key="prmDummy1_stop_0" on_node="rh72-01" on_node_uuid="3232238257"/>
+      </trigger>
+    </inputs>
+  </synapse>
+</transition_graph>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.scores
===================================================================
--- /dev/null
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.scores
@@ -0,0 +1,12 @@
+Allocation scores:
+Using the original execution date of: 2016-10-05 07:32:34Z
+group_color: grpDummy allocation score on rh72-01: 200
+group_color: grpDummy allocation score on rh72-02: 100
+group_color: prmDummy1 allocation score on rh72-01: INFINITY
+group_color: prmDummy1 allocation score on rh72-02: 100
+group_color: prmDummy2 allocation score on rh72-01: 0
+group_color: prmDummy2 allocation score on rh72-02: 0
+native_color: prmDummy1 allocation score on rh72-01: -INFINITY
+native_color: prmDummy1 allocation score on rh72-02: 100
+native_color: prmDummy2 allocation score on rh72-01: -INFINITY
+native_color: prmDummy2 allocation score on rh72-02: 0
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.summary
===================================================================
--- /dev/null
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.summary
@@ -0,0 +1,36 @@
+Using the original execution date of: 2016-10-05 07:32:34Z
+
+Current cluster status:
+Node rh72-01 (3232238257): standby
+Online: [ rh72-02 ]
+
+ Resource Group: grpDummy
+     prmDummy1	(ocf::pacemaker:Dummy1):	Started rh72-01
+     prmDummy2	(ocf::pacemaker:Dummy2):	Stopped
+
+Transition Summary:
+ * Move       prmDummy1     ( rh72-01 -> rh72-02 )  
+ * Start      prmDummy2     (            rh72-02 )  
+
+Executing cluster transition:
+ * Pseudo action:   grpDummy_stop_0
+ * Resource action: prmDummy2       monitor on rh72-01
+ * Resource action: prmDummy1       stop on rh72-01
+ * Pseudo action:   all_stopped
+ * Pseudo action:   grpDummy_stopped_0
+ * Pseudo action:   grpDummy_start_0
+ * Resource action: prmDummy1       start on rh72-02
+ * Resource action: prmDummy2       start on rh72-02
+ * Pseudo action:   grpDummy_running_0
+ * Resource action: prmDummy1       monitor=10000 on rh72-02
+ * Resource action: prmDummy2       monitor=10000 on rh72-02
+Using the original execution date of: 2016-10-05 07:32:34Z
+
+Revised cluster status:
+Node rh72-01 (3232238257): standby
+Online: [ rh72-02 ]
+
+ Resource Group: grpDummy
+     prmDummy1	(ocf::pacemaker:Dummy1):	Started rh72-02
+     prmDummy2	(ocf::pacemaker:Dummy2):	Started rh72-02
+
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.xml
===================================================================
--- /dev/null
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order-first-probes.xml
@@ -0,0 +1,96 @@
+<cib crm_feature_set="3.0.10" validate-with="pacemaker-2.5" epoch="6" num_updates="5" admin_epoch="0" cib-last-written="Wed Oct  5 16:29:29 2016" update-origin="rh72-01" update-client="crm_attribute" update-user="root" have-quorum="1" dc-uuid="3232238258" execution-date="1475652754">
+  <configuration>
+    <crm_config>
+      <cluster_property_set id="cib-bootstrap-options">
+        <nvpair id="cib-bootstrap-options-have-watchdog" name="have-watchdog" value="false"/>
+        <nvpair id="cib-bootstrap-options-dc-version" name="dc-version" value="1.1.15-e174ec8"/>
+        <nvpair id="cib-bootstrap-options-cluster-infrastructure" name="cluster-infrastructure" value="corosync"/>
+        <nvpair id="cib-bootstrap-options-cluster-name" name="cluster-name" value="cluster1"/>
+        <nvpair name="no-quorum-policy" value="ignore" id="cib-bootstrap-options-no-quorum-policy"/>
+        <nvpair name="stonith-enabled" value="false" id="cib-bootstrap-options-stonith-enabled"/>
+        <nvpair name="startup-fencing" value="false" id="cib-bootstrap-options-startup-fencing"/>
+      </cluster_property_set>
+    </crm_config>
+    <nodes>
+      <node id="3232238257" uname="rh72-01">
+        <instance_attributes id="nodes-3232238257">
+          <nvpair id="nodes-3232238257-standby" name="standby" value="on"/>
+        </instance_attributes>
+      </node>
+      <node id="3232238258" uname="rh72-02"/>
+    </nodes>
+    <resources>
+      <group id="grpDummy">
+        <!--### Group Configuration ###-->
+        <primitive id="prmDummy1" class="ocf" provider="pacemaker" type="Dummy1">
+          <!--### Primitive Configuration ###-->
+          <operations>
+            <op name="start" interval="0s" timeout="60s" on-fail="restart" id="prmDummy1-start-0s"/>
+            <op name="monitor" interval="10s" timeout="60s" on-fail="restart" id="prmDummy1-monitor-10s"/>
+            <op name="stop" interval="0s" timeout="60s" on-fail="block" id="prmDummy1-stop-0s"/>
+          </operations>
+        </primitive>
+        <primitive id="prmDummy2" class="ocf" provider="pacemaker" type="Dummy2">
+          <operations>
+            <op name="start" interval="0s" timeout="60s" on-fail="restart" id="prmDummy2-start-0s"/>
+            <op name="monitor" interval="10s" timeout="60s" on-fail="restart" id="prmDummy2-monitor-10s"/>
+            <op name="stop" interval="0s" timeout="60s" on-fail="block" id="prmDummy2-stop-0s"/>
+          </operations>
+        </primitive>
+      </group>
+    </resources>
+    <constraints>
+      <rsc_location id="rsc_location-msDrbd-1" rsc="grpDummy">
+        <!--### Resource Location ###-->
+        <rule score="200" id="rsc_location-msDrbd-1-rule">
+          <expression attribute="#uname" operation="eq" value="rh72-01" id="rsc_location-msDrbd-1-rule-expression"/>
+        </rule>
+        <rule score="100" id="rsc_location-msDrbd-1-rule-0">
+          <expression attribute="#uname" operation="eq" value="rh72-02" id="rsc_location-msDrbd-1-rule-0-expression"/>
+        </rule>
+      </rsc_location>
+    </constraints>
+    <rsc_defaults>
+      <meta_attributes id="rsc-options">
+        <!--### Resource Defaults ###-->
+        <nvpair name="resource-stickiness" value="INFINITY" id="rsc-options-resource-stickiness"/>
+        <nvpair name="migration-threshold" value="1" id="rsc-options-migration-threshold"/>
+      </meta_attributes>
+    </rsc_defaults>
+  </configuration>
+  <status>
+    <node_state id="3232238257" uname="rh72-01" in_ccm="true" crmd="online" crm-debug-origin="do_update_resource" join="member" expected="member">
+      <lrm id="3232238257">
+        <lrm_resources>
+          <lrm_resource id="prmDummy1" type="Dummy1" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="prmDummy1_last_0" operation_key="prmDummy1_start_0" operation="start" crm-debug-origin="do_update_resource" crm_feature_set="3.0.10" transition-key="6:1:0:772ebf03-a8fe-44e7-9215-61b49015d8b0" transition-magic="0:0;6:1:0:772ebf03-a8fe-44e7-9215-61b49015d8b0" on_node="rh72-01" call-id="10" rc-code="0" op-status="0" interval="0" last-run="1475652256" last-rc-change="1475652256" exec-time="43" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" op-force-restart=" state  passwd  op_sleep  envfile " op-restart-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" op-secure-params=" passwd " op-secure-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+            <lrm_rsc_op id="prmDummy1_monitor_10000" operation_key="prmDummy1_monitor_10000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.10" transition-key="7:1:0:772ebf03-a8fe-44e7-9215-61b49015d8b0" transition-magic="0:0;7:1:0:772ebf03-a8fe-44e7-9215-61b49015d8b0" on_node="rh72-01" call-id="11" rc-code="0" op-status="0" interval="10000" last-rc-change="1475652256" exec-time="40" queue-time="0" op-digest="873ed4f07792aa8ff18f3254244675ea" op-secure-params=" passwd " op-secure-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+      <transient_attributes id="3232238257">
+        <instance_attributes id="status-3232238257">
+          <nvpair id="status-3232238257-shutdown" name="shutdown" value="0"/>
+          <nvpair id="status-3232238257-last-failure-prmDummy2" name="last-failure-prmDummy2" value="1475652569"/>
+        </instance_attributes>
+      </transient_attributes>
+    </node_state>
+    <node_state id="3232238258" uname="rh72-02" in_ccm="true" crmd="online" crm-debug-origin="do_update_resource" join="member" expected="member">
+      <lrm id="3232238258">
+        <lrm_resources>
+          <lrm_resource id="prmDummy1" type="Dummy1" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="prmDummy1_last_0" operation_key="prmDummy1_monitor_0" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.10" transition-key="4:1:7:772ebf03-a8fe-44e7-9215-61b49015d8b0" transition-magic="0:7;4:1:7:772ebf03-a8fe-44e7-9215-61b49015d8b0" on_node="rh72-02" call-id="5" rc-code="7" op-status="0" interval="0" last-run="1475652357" last-rc-change="1475652357" exec-time="46" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" op-force-restart=" state  passwd  op_sleep  envfile " op-restart-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" op-secure-params=" passwd " op-secure-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+          <lrm_resource id="prmDummy2" type="Dummy2" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="prmDummy2_last_0" operation_key="prmDummy2_monitor_0" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.10" transition-key="5:1:7:772ebf03-a8fe-44e7-9215-61b49015d8b0" transition-magic="0:7;5:1:7:772ebf03-a8fe-44e7-9215-61b49015d8b0" on_node="rh72-02" call-id="9" rc-code="7" op-status="0" interval="0" last-run="1475652357" last-rc-change="1475652357" exec-time="43" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" op-force-restart=" state  passwd  op_sleep  envfile " op-restart-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" op-secure-params=" passwd " op-secure-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+      <transient_attributes id="3232238258">
+        <instance_attributes id="status-3232238258">
+          <nvpair id="status-3232238258-shutdown" name="shutdown" value="0"/>
+        </instance_attributes>
+      </transient_attributes>
+    </node_state>
+  </status>
+</cib>