commit d51f0cf42e02eba13a4090ce9b181ccb920fd382
Author: Ken Gaillot <kgaillot@redhat.com>
Date:   Fri Apr 20 14:13:39 2018 -0500

    Log: all: correct misspellings

Index: pacemaker-1.1.18+20180417.e3639389e/attrd/commands.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/attrd/commands.c
+++ pacemaker-1.1.18+20180417.e3639389e/attrd/commands.c
@@ -36,7 +36,7 @@
  *                      ATTRD_OP_SYNC, ATTRD_OP_SYNC_RESPONSE
  *     1       1.1.13   ATTRD_OP_UPDATE (with F_ATTR_REGEX), ATTRD_OP_QUERY
  *     1       1.1.15   ATTRD_OP_UPDATE_BOTH, ATTRD_OP_UPDATE_DELAY
- *     2       1.1.17   ATTRD_OP_CLEAR_FAILCOUNT
+ *     2       1.1.17   ATTRD_OP_CLEAR_FAILURE
  */
 #define ATTRD_PROTOCOL_VERSION "2"
 
Index: pacemaker-1.1.18+20180417.e3639389e/crmd/lrm.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/crmd/lrm.c
+++ pacemaker-1.1.18+20180417.e3639389e/crmd/lrm.c
@@ -2465,7 +2465,7 @@ do_update_resource(const char *node_name
      *   (probably because of an internal error)
      *
      * Worst case:
-     *   we get shot for having resources "running" when the really weren't
+     *   we get shot for having resources "running" that really weren't
      *
      * the alternative however means blocking here for too long, which
      * isn't acceptable
Index: pacemaker-1.1.18+20180417.e3639389e/crmd/throttle.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/crmd/throttle.c
+++ pacemaker-1.1.18+20180417.e3639389e/crmd/throttle.c
@@ -49,7 +49,7 @@ static mainloop_timer_t *throttle_timer
 #if SUPPORT_PROCFS
 /*!
  * \internal
- * \brief Return name of /proc file containing the CIB deamon's load statistics
+ * \brief Return name of /proc file containing the CIB daemon's load statistics
  *
  * \return Newly allocated memory with file name on success, NULL otherwise
  *
Index: pacemaker-1.1.18+20180417.e3639389e/crmd/utils.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/crmd/utils.c
+++ pacemaker-1.1.18+20180417.e3639389e/crmd/utils.c
@@ -1,19 +1,8 @@
 /*
- * Copyright (C) 2004 Andrew Beekhof <andrew@beekhof.net>
+ * Copyright 2004-2018 Andrew Beekhof <andrew@beekhof.net>
  *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public
- * License as published by the Free Software Foundation; either
- * version 2 of the License, or (at your option) any later version.
- *
- * This software is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public
- * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ * This source code is licensed under the GNU General Public License version 2
+ * or later (GPLv2+) WITHOUT ANY WARRANTY.
  */
 
 #include <crm_internal.h>
@@ -184,7 +173,7 @@ crm_timer_start(fsa_timer_t * timer)
                   timer->period_ms, timer->source_id);
 
     } else if (timer->period_ms < 0) {
-        crm_err("Tried to start %s (%s:%dms) with a -ve period",
+        crm_err("Tried to start %s (%s:%dms) with a negative period",
                 timer_desc, fsa_input2string(timer->fsa_input), timer->period_ms);
 
     } else {
Index: pacemaker-1.1.18+20180417.e3639389e/cts/CM_lha.py
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/cts/CM_lha.py
+++ pacemaker-1.1.18+20180417.e3639389e/cts/CM_lha.py
@@ -254,10 +254,7 @@ class crm_lha(ClusterManager):
         return rc
 
     def active_resources(self, node):
-        # [SM].* {node} matches Started, Slave, Master
-        # Stopped wont be matched as it wont include {node}
         (rc, output) = self.rsh(node, """crm_resource -c""", None)
-
         resources = []
         for line in output: 
             if re.search("^Resource", line):
Index: pacemaker-1.1.18+20180417.e3639389e/cts/CTStests.py
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/cts/CTStests.py
+++ pacemaker-1.1.18+20180417.e3639389e/cts/CTStests.py
@@ -287,7 +287,7 @@ class StopTest(CTSTest):
         #    patterns.append(self.templates["Pat:Logd_stopped"] % node)
 
         # Any active node needs to notice this one left
-        # NOTE: This wont work if we have multiple partitions
+        # (note that this won't work if we have multiple partitions)
         for other in self.Env["nodes"]:
             if self.CM.ShouldBeStatus[other] == "up" and other != node:
                 patterns.append(self.templates["Pat:They_stopped"] %(other, self.CM.key_for_node(node)))
Index: pacemaker-1.1.18+20180417.e3639389e/pengine/regression.sh
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/pengine/regression.sh
+++ pacemaker-1.1.18+20180417.e3639389e/pengine/regression.sh
@@ -59,7 +59,7 @@ do_test group9 "Group recovery"
 do_test group10 "Group partial recovery"
 do_test group11 "Group target_role"
 do_test group14 "Group stop (graph terminated)"
-do_test group15 "-ve group colocation"
+do_test group15 "Negative group colocation"
 do_test bug-1573 "Partial stop of a group with two children"
 do_test bug-1718 "Mandatory group ordering - Stop group_FUN"
 do_test bug-lf-2613 "Move group on failure"
Index: pacemaker-1.1.18+20180417.e3639389e/extra/cluster-init
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/extra/cluster-init
+++ pacemaker-1.1.18+20180417.e3639389e/extra/cluster-init
@@ -1,4 +1,10 @@
 #!/bin/bash
+#
+# Copyright 2011-2018 Andrew Beekhof <andrew@beekhof.net>
+#
+# This source code is licensed under the GNU General Public License version 2
+# or later (GPLv2+) WITHOUT ANY WARRANTY.
+#
 
 accept_defaults=0
 do_raw=0
@@ -260,7 +266,7 @@ if [ $accept_defaults = 0 ]; then
 	read -p "Shall I set one? [No] (domain.name) " -t 60 DOMAIN
     elif [ $pcmk_ver = 10 ]; then
 	echo ""
-	echo "Without a default domain, external/ssh fencing probably wont work because it can't find its peers"
+	echo "Without a default domain, external/ssh fencing probably won't work because it can't find its peers"
 	read -p "Shall I set one? [No] (domain.name) " -t 60 DOMAIN
     fi
 
Index: pacemaker-1.1.18+20180417.e3639389e/fencing/remote.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/fencing/remote.c
+++ pacemaker-1.1.18+20180417.e3639389e/fencing/remote.c
@@ -423,13 +423,14 @@ handle_duplicates(remote_fencing_op_t *
         remote_fencing_op_t *other = iter->data;
 
         if (other->state == st_duplicate) {
-            /* Ie. it hasn't timed out already */
             other->state = op->state;
-            crm_debug("Peforming duplicate notification for %s@%s.%.8s = %s", other->client_name,
-                      other->originator, other->id, pcmk_strerror(rc));
+            crm_debug("Performing duplicate notification for %s@%s.%.8s = %s",
+                      other->client_name, other->originator, other->id,
+                      pcmk_strerror(rc));
             remote_op_done(other, data, rc, TRUE);
 
         } else {
+            // Possible if (for example) it timed out already
             crm_err("Skipping duplicate notification for %s@%s - %d", other->client_name,
                     other->originator, other->state);
         }
Index: pacemaker-1.1.18+20180417.e3639389e/lib/common/iso8601.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/lib/common/iso8601.c
+++ pacemaker-1.1.18+20180417.e3639389e/lib/common/iso8601.c
@@ -1,19 +1,8 @@
 /*
- * Copyright (C) 2005 Andrew Beekhof <andrew@beekhof.net>
+ * Copyright 2005-2018 Andrew Beekhof <andrew@beekhof.net>
  *
- * This library is free software; you can redistribute it and/or
- * modify it under the terms of the GNU Lesser General Public
- * License as published by the Free Software Foundation; either
- * version 2.1 of the License, or (at your option) any later version.
- *
- * This library is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ * This source code is licensed under the GNU Lesser General Public License
+ * version 2.1 or later (LGPLv2.1+) WITHOUT ANY WARRANTY.
  */
 
 /*
@@ -470,13 +459,13 @@ crm_time_as_string(crm_time_t * date_tim
         } else if (flags & crm_time_seconds) {
             long long s = crm_time_get_seconds(date_time);
 
-            snprintf(date_s, 32, "%lld", s); /* Durations may not be +ve */
+            snprintf(date_s, 32, "%lld", s);
             goto done;
 
         } else if (flags & crm_time_epoch) {
             long long s = crm_time_get_seconds_since_epoch(date_time);
 
-            snprintf(date_s, 32, "%lld", s); /* Durations may not be +ve */
+            snprintf(date_s, 32, "%lld", s);
             goto done;
 
         } else if (flags & crm_time_weeks) {
Index: pacemaker-1.1.18+20180417.e3639389e/lib/pengine/unpack.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/lib/pengine/unpack.c
+++ pacemaker-1.1.18+20180417.e3639389e/lib/pengine/unpack.c
@@ -1,20 +1,10 @@
 /*
- * Copyright (C) 2004 Andrew Beekhof <andrew@beekhof.net>
+ * Copyright 2004-2018 Andrew Beekhof <andrew@beekhof.net>
  *
- * This library is free software; you can redistribute it and/or
- * modify it under the terms of the GNU Lesser General Public
- * License as published by the Free Software Foundation; either
- * version 2.1 of the License, or (at your option) any later version.
- *
- * This library is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ * This source code is licensed under the GNU Lesser General Public License
+ * version 2.1 or later (LGPLv2.1+) WITHOUT ANY WARRANTY.
  */
+
 #include <crm_internal.h>
 
 #include <glib.h>
@@ -1157,7 +1147,7 @@ unpack_node_loop(xmlNode * status, bool
 }
 
 /* remove nodes that are down, stopping */
-/* create +ve rsc_to_node constraints between resources and the nodes they are running on */
+/* create positive rsc_to_node constraints between resources and the nodes they are running on */
 /* anything else? */
 gboolean
 unpack_status(xmlNode * status, pe_working_set_t * data_set)
Index: pacemaker-1.1.18+20180417.e3639389e/mcp/pacemaker.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/mcp/pacemaker.c
+++ pacemaker-1.1.18+20180417.e3639389e/mcp/pacemaker.c
@@ -1036,7 +1036,7 @@ main(int argc, char **argv)
         if (rc < 0) {
             crm_perror(LOG_ERR,
                        "Core file generation will remain disabled."
-                       " Core files are an important diagnositic tool,"
+                       " Core files are an important diagnostic tool, so"
                        " please consider enabling them by default.");
         }
     }
Index: pacemaker-1.1.18+20180417.e3639389e/pengine/native.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/pengine/native.c
+++ pacemaker-1.1.18+20180417.e3639389e/pengine/native.c
@@ -1,19 +1,8 @@
 /*
- * Copyright (C) 2004 Andrew Beekhof <andrew@beekhof.net>
+ * Copyright 2004-2018 Andrew Beekhof <andrew@beekhof.net>
  *
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public
- * License as published by the Free Software Foundation; either
- * version 2 of the License, or (at your option) any later version.
- *
- * This software is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- *
- * You should have received a copy of the GNU General Public
- * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ * This source code is licensed under the GNU General Public License version 2
+ * or later (GPLv2+) WITHOUT ANY WARRANTY.
  */
 
 #include <crm_internal.h>
@@ -685,7 +674,8 @@ RecurringOp(resource_t * rsc, action_t *
     }
 
     if (op_cannot_recur(name)) {
-        crm_config_err("Invalid recurring action %s wth name: '%s'", ID(operation), name);
+        crm_config_err("Ignoring %s because action '%s' cannot be recurring",
+                       ID(operation), name);
         return;
     }
 
@@ -1302,7 +1292,7 @@ native_create_actions(resource_t * rsc,
         Recurring(rsc, start, chosen, data_set);
         Recurring_Stopped(rsc, start, chosen, data_set);
     } else {
-        pe_rsc_trace(rsc, "Monitor ops for in-active resource");
+        pe_rsc_trace(rsc, "Monitor ops for inactive resource");
         Recurring_Stopped(rsc, NULL, NULL, data_set);
     }
 
@@ -1616,14 +1606,14 @@ filter_colocation_constraint(resource_t
 
     if (constraint->score < 0
         && constraint->role_lh != RSC_ROLE_UNKNOWN && constraint->role_lh == rsc_lh->next_role) {
-        crm_trace("LH: Skipping -ve constraint: \"%s\" state filter",
+        crm_trace("LH: Skipping negative constraint: \"%s\" state filter",
                   role2text(constraint->role_lh));
         return influence_nothing;
     }
 
     if (constraint->score < 0
         && constraint->role_rh != RSC_ROLE_UNKNOWN && constraint->role_rh == rsc_rh->next_role) {
-        crm_trace("RH: Skipping -ve constraint: \"%s\" state filter",
+        crm_trace("RH: Skipping negative constraint: \"%s\" state filter",
                   role2text(constraint->role_rh));
         return influence_nothing;
     }
Index: pacemaker-1.1.18+20180417.e3639389e/pengine/notif.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/pengine/notif.c
+++ pacemaker-1.1.18+20180417.e3639389e/pengine/notif.c
@@ -490,7 +490,7 @@ collect_notification_data(resource_t * r
                 task = text2task(op->task);
 
                 if(task == stop_rsc && op->node->details->unclean) {
-                    /* Create one anyway,, some additional noise if op->node cannot be fenced */
+                    // Create anyway (additional noise if node can't be fenced)
                 } else if(is_not_set(op->flags, pe_action_runnable)) {
                     continue;
                 }
Index: pacemaker-1.1.18+20180417.e3639389e/tools/test.iso8601.c
===================================================================
--- pacemaker-1.1.18+20180417.e3639389e.orig/tools/test.iso8601.c
+++ pacemaker-1.1.18+20180417.e3639389e/tools/test.iso8601.c
@@ -1,19 +1,8 @@
-/* 
- * Copyright (C) 2005 Andrew Beekhof <andrew@beekhof.net>
- * 
- * This program is free software; you can redistribute it and/or
- * modify it under the terms of the GNU General Public
- * License as published by the Free Software Foundation; either
- * version 2 of the License, or (at your option) any later version.
- * 
- * This software is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public
- * License along with this library; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+/*
+ * Copyright 2005-2018 Andrew Beekhof <andrew@beekhof.net>
+ *
+ * This source code is licensed under the GNU General Public License version 2
+ * or later (GPLv2+) WITHOUT ANY WARRANTY.
  */
 
 #include <crm_internal.h>
@@ -33,10 +22,15 @@ static struct crm_option long_options[]
     {"-spacer-",    0, 0, '-', "\nCommands:"},
     {"now",      0, 0, 'n', "\tDisplay the current date/time"},
     {"date",     1, 0, 'd', "Parse an ISO8601 date/time.  Eg. '2005-01-20 00:30:00 +01:00' or '2005-040'"},
-    {"period",   1, 0, 'p', "Parse an ISO8601 date/time with interval/period (wth start time).  Eg. '2005-040/2005-043'"},
-    {"duration", 1, 0, 'D', "Parse an ISO8601 date/time with duration (wth start time). Eg. '2005-040/P1M'"},
-    {"expected", 1, 0, 'E', "Parse an ISO8601 date/time with duration (wth start time). Eg. '2005-040/P1M'"},
-
+    { "period",   1, 0, 'p',
+      "Parse an ISO8601 period (interval) with start time (for example, '2005-040/2005-043')"
+    },
+    { "duration", 1, 0, 'D',
+      "Parse an ISO8601 duration with start time (for example, '2005-040/P1M')"
+    },
+    { "expected", 1, 0, 'E',
+      "Parse an ISO8601 duration with start time (for example, '2005-040/P1M')"
+    },
     {"-spacer-",0, 0, '-', "\nOutput Modifiers:"},
     {"seconds", 0, 0, 's', "\tShow result as a seconds since 0000-001 00:00:00Z"},
     {"epoch", 0, 0, 'S', "\tShow result as a seconds since EPOCH (1970-001 00:00:00Z)"},